/*
	charctor graph
*/
#include <stdio.h>

float	num(unsigned char *);
char	t2(int);
char	t1(int);

main()
{	FILE	*input_file, *output_file;
	int	i, j, k, l, f_size, f_form;
	unsigned char
		file_name[30],o_name[30],o_date[30],o_mag[30],o_obs[30];
	float	o_data[2][500];
	unsigned char
		disp_array[80][80];
	float	x_maxf, y_maxf, x_minf, y_minf;
	int	x_max, y_max, x_min, y_min, x_colm, y_colm;
	int	x_step, y_step;

	printf ( "data file format (vsolj=1 , vsnet=0) ");
	scanf  ( "%d" , &f_form );
main_top:
	f_size = -1;
	x_maxf = (float)-99; y_maxf = (float)-99; x_minf = (float)99; y_minf = (float)99;
	printf( "\ndata file name = ");
	scanf ( "%s" , file_name );
	if ((input_file = fopen(file_name, "r")) == NULL)
		{
		printf("Cannot open input file. %d\n",input_file);
		return 1;
		}
	while (!feof(input_file))
		{	fscanf(input_file,"%s %s %s %s",o_name, o_date, o_mag, o_obs);
			f_size ++;
			if ( f_form == 1 )
			{	o_data[0][f_size]  = (float) ( (o_date[ 8]-48) * 10 + (o_date[ 9]-48) );
				o_data[0][f_size] += (float) ( (o_date[10]-48) * 10 + (o_date[11]-48) ) / (float)60;
			}
			else
			{	i = 0;
				do
				{	o_date[i] = '0';
					i ++;
				}
				while ( o_date[i] != '.' );
				o_data[0][f_size] = num( o_date ) * 24;
			}
			o_data[1][f_size] = num( o_mag );
			if ( o_data[1][f_size] > 20 ) o_data[1][f_size] /= 10;
			printf ("  %5.2f %7.3f \n",o_data[0][f_size],o_data[1][f_size]);
		}
	i = fclose(input_file);
	if (i)
		{
		printf("file close error. %d\n" , i );
		return 1;
		}

	for ( i=0 ; i<=f_size ; i++ )
	{	if ( x_maxf < o_data[0][i] ) x_maxf = o_data[0][i];
		if ( x_minf > o_data[0][i] ) x_minf = o_data[0][i];
		if ( y_maxf < o_data[1][i] ) y_maxf = o_data[1][i];
		if ( y_minf > o_data[1][i] ) y_minf = o_data[1][i];
	}
	x_max = (int)(x_maxf + 1.0);
	x_min = (int)(x_minf);
	y_max = (int)(y_maxf + 1.0);
	y_min = (int)(y_minf);
	printf ( "\nY max=%d min=%d / X max=%d min=%d\n\n",y_max, y_min, x_max, x_min);

graph_rewrite:
	for ( i=0 ; i<=79 ; i++ )
		for ( j=0 ; j<=79 ; j++ )
			disp_array[j][i] = ' ';

	printf ( "mag. axis (colum, max=79) = ");
	scanf  ( "%d" , &y_colm );
	printf ( "hour axis (colum, max=79) = ");
	scanf  ( "%d" , &x_colm );
	printf ( "\n" );

	y_step = ( y_colm - 2 ) / ( y_max - y_min ) ;
	x_step = ( x_colm - 4 ) / ( x_max - x_min ) ;
	for ( i=2 ; i<=y_colm ; i++) disp_array[3][i] = '|';
	for ( i=4 ; i<=x_colm ; i++) disp_array[i][1] = '-';
	for ( i=y_max ; i>=y_min ; i-- )
	{	j = ( y_max - i ) * y_step + 2;
		disp_array[0][j] = t2(i);
		disp_array[1][j] = t1(i);
		disp_array[3][j] = '+';
	}
	if ( y_step >> 2 )
	{	for ( i=y_max ; i>=(y_min+1) ; i-- )
		{	j = ( y_max - i ) * y_step + 2 + y_step/2;
			disp_array[3][j] = '+';
		}
	}
	for ( i=x_min ; i<=x_max ; i++ )
	{	j = ( ( i - x_min ) * x_step ) + 3;
		disp_array[j+1][1] = '+';
		disp_array[j  ][0] = t2(i);
		disp_array[j+1][0] = t1(i);
	}
	for ( i=0 ; i<=f_size ; i++)
	{	j = (int)(( o_data[0][i] - x_min ) * x_step + 4.5);
		k = (int)(( y_max - o_data[1][i] ) * y_step + 2.5);
		disp_array[j][k] = '*';
	}
	for ( i=y_colm ; i>=0 ; i-- )
	{	for ( j=0 ; j<=x_colm ; j++ )
		{	printf ( "%c" , disp_array[j][i] );
		}
		printf("\n");
	}
	printf ( "\nDo you rewrite the graph ? (yes=1 , no=0) ");
	scanf  ( "%d" , &l );
	if ( l == 1 ) goto graph_rewrite;
	printf ( "\ngraph save ? (yes=1 , no=0) ");
	scanf  ( "%d" , &l );
	if ( l == 1 )
	{	printf ( "graph file name = ");
		scanf  ( "%s" , &file_name);
		output_file = fopen(file_name, "w");
		for ( i=y_colm ; i>=0 ; i-- )
		{	for ( j=0 ; j<=x_colm ; j++ )
				fprintf ( output_file, "%c" , disp_array[j][i] );
			fprintf( output_file, "\n");
		}
		i = fclose(input_file);
		if (i)
			{
			printf("file close error. %d\n" , i );
			return 1;
			}
	}

	printf ( "\nDo you continue ? (yes=1 , no=0) ");
	scanf  ( "%d" , &l );
	if ( l == 1 ) goto main_top;
	return 0;
}

float num(unsigned char *f_data)
{	float	ans = (float)0 , f_c = (float)1 ;
	int		i, brch = 0 ;
	for ( i=0 ; i <= 20 ; i++ )
	{	if ( f_data[i] != 0 && f_data[i] < 'A' ) 
		{	if ( f_data[i] == '.' )
				brch = 1;
			else
			{	if ( brch == 0 )
				{	ans = ans * 10;
					ans += ( (float)f_data[i] - (float)48 );
				}
				else
				{	f_c = f_c / (float)10;
					ans += (( (float)f_data[i] - (float)48 ) * f_c );
				}
			}
		}
		else	return ( ans );
	}
	return ( ans );
}

char t2(int i)
{	i=i/10;
	return ( i + 0x30 );

}

char t1(int i)
{
	i=i-((i/10)*10);
	return ( i + 0x30 );
}
